#include <algorithm>
#include <iostream>
#include <cstring>
#include <vector>

using namespace std;

const int MAXN = 505;
const int MAXS = 100010; 
const int INF  = 1e9;

int n, sum;
vector<int> c;
int memory[MAXN][MAXS/2];

int rec(int pos, int diff) {

  if (diff > sum / 2) 
    return -INF;

  int& memo_ref = memory[pos][diff];

  if (memo_ref != -1)
    return memo_ref;

  if (pos == n)
    return memo_ref = (diff != 0) * (-INF);

  return memo_ref = max({rec(pos + 1, diff), 
                         rec(pos + 1, diff + c[pos]) + c[pos], 
                         rec(pos + 1, abs(diff - c[pos])) + max(0, c[pos] - diff)});

}

int main() {
 
  memset(memory, -1, sizeof memory);

  cin >> n;
  c.resize(n);
  for (int i = 0; i < n; ++i) {
    cin >> c[i];
    sum += c[i];
  }

  int common = rec(0, 0);
  cout << sum - common << '\n';

}
