using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;
using answer = pair<double, int>;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    set<int> a;

    for (int i = 0; i < k; ++i) {
        int t;
        cin >> t;
        a.insert(t);
    }

    set<pair<int, int>> ed;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;

        if (u == n && a.find(v) != a.end() || v == n && a.find(u) != a.end()) {
            cout << -1 << "\n";
            return 0;
        }

        if (u > v) swap(u, v);
        ed.emplace(u, v);
    }

    ll ans = 0;
    for (int i = 1; i < n; ++i) {
        for (int j = i + 1; j <= n; ++j) {
            if (j == n && a.find(i) != a.end()) continue;
            if (ed.find(make_pair(i, j)) == ed.end()) {
                ans += 1;
//                cout << "+" << i << " " << j <<"\n";
            }
        }
    }
    cout << ans << "\n";
}