#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_r = opt<int>("r");

    set<pair<int, int>> points;
    while (points.size() < 3) {
        int x = rnd.next(-max_r, max_r);
        int y = rnd.next(-max_r, max_r);
        points.insert(make_pair(x, y));
    }

    for (auto p : points) {
        printf("%d %d\n", p.first, p.second);
    }

    return 0;
}
