#include "bits/stdc++.h"
#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int NM = 1e6;

    int n, m;

    if (has_opt("n")) {
        n = opt<int>("n");
        m = has_opt("m") ? opt<int>("m") : NM / n;
    } else if (has_opt("m")) {
        m = opt<int>("m");
        n = NM / m;
    } else {
        n = 1000;
        m = 1000;
    }

    int min_h = has_opt("min_h") ? opt<int>("min_h") : 0;
    int max_h = has_opt("max_h") ? opt<int>("max_h") : (int)1e9;

    println(n, m);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << rnd.next(min_h, max_h) << " \n"[j == m - 1];
        }
    }
}
