#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pi = pair<ll,ll>;

ll n, m, ans = 0;
vector <ll> dsu, ves, maxi, connect;

ll K(ll v) {
    if (dsu[v] == v) return v;
    return dsu[v] = K(dsu[v]);
}

void SO(ll v, ll u) {
    v = K(v);
    u = K(u);
    if (v == u || maxi[v] < maxi[u]) return;
    if (connect[u] < 1) ans += (maxi[v] - maxi[u]) * ves[u];
    if (ves[v] < ves[u]) swap(v, u);
    dsu[u] = v;
    ves[v] += ves[u];
    maxi[v] = max(maxi[v], maxi[u]);
    connect[v] = max(connect[v], connect[u]);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll i, j;
    cin >> n >> m;
    dsu.resize(n*m);
    ves.resize(n*m, 1);
    maxi = connect = dsu;
    vector <pi> sor(n*m);
    for (i = 0; i < n*m; i++) {
        dsu[i] = i;
        cin >> maxi[i];
        sor[i] = {maxi[i], i};
        if (i < m || i >= n * m - m || i % m == 0 || i % m == m-1) connect[i] = 1;
    }
    sort(sor.begin(), sor.end());
    for (i = 0; i < n*m; i++) {
        j = sor[i].second;
        if (j >= m) SO(j, j-m);
        if (j < n * m - m) SO(j, j + m);
        if (j % m) SO(j, j-1);
        if (j % m < m - 1) SO(j, j + 1);
    }
    cout << ans;
}
