#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int _run = ouf.readInt();

    if (_run != -1) {
        while (!ouf.eof()) ouf.skipChar();
        quitf(_ok, "first run");
    }

    inf.readInt();
    long long n = inf.readLong();
    int limit = (int) (sqrt(2) * ceil(log2(n)) + 5);

    long long result = ouf.readLong();
    int sz = ouf.readInt();
    ouf.readToken("[01]{1,1000}");

    while (!ouf.eof()) ouf.skipChar();

    if (sz > limit) quitf(_wa, "information string is too long: %d > %d", sz, limit);
    if (result != n) {
        quitf(_wa, "incorrectly guessed the initial number");
    }
    quitf(_ok, "restored in %d bits", sz);

}
