/*
Author: @doreshnikov
Created on: 11.10.2024/23:20
*/

#include <vector>
#include <iostream>
#include <string>

using namespace std;

typedef unsigned long long ull;
typedef unsigned int uint;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}

#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

ull const LIMIT = 1000'000'000'000'000'000;

int main() {

    vector<ull> fib{1, 1};
    while (fib.back() < LIMIT) {
        fib.push_back(fib[fib.size() - 2] + fib[fib.size() - 1]);
    }

    in(int, _run)

    if (_run == 1) {

        in(ull, n)
        bool started = false;
        for (int i = (int) fib.size() - 1; i > 0; i--) {
            if (n >= fib[i]) {
                n -= fib[i];
                started = true;
                cout << "1";
            } else if (started) {
                cout << "0";
            }
        }
        cout << "110\n";

    } else {

        in(string, q)
        ull n = 0;
        uint pos = q.find("110");
        for (int i = 0; i < pos; i++) {
            if (q[pos - i - 1] == '1') {
                n += fib[i + 1];
            }
        }
        cout << n << '\n';

    }

}