#include <bits/stdc++.h>
#include "testlib.h"

void check(int test_case) {
    int start = inf.readInt(0, 500'000, "secret");

    int current = start;
    for (int i = 0;; i++) {
        std::string c = ouf.readWord();

        if (c == "?") {
            int guess = ouf.readInt(1, 1'000'000'000, "part_guess");
            if (current % guess == 0) {
                std::cout << 1 << std::endl;
            } else {
                std::cout << 0 << std::endl;
                --current;
            }
        } else if (c == "!") {
            int part_ans = ouf.readInt();
            std::cout << ((part_ans == start) ? 1 : 0) << std::endl;

            tout << i << ' ' << start << std::endl;

            if (part_ans != start) {
                quitf(_wa, "expected %d, got %d in testcase %d", start, part_ans, test_case);
            }
            return;
        } else {
            quitf(_wa, "unknown character: %s in test case %d", c.c_str(), test_case);
        }
    }
}

int main(int argc, char *argv[]) {
    registerInteraction(argc, argv);

    int tests = inf.readInt();

    std::cout << tests << std::endl;

    for (int test = 1; test <= tests; test++) {
        setTestCase(test);
        check(test);
    }
    quitf(_ok, "all testcases passed");
}