#include <bits/stdc++.h>

using namespace std;

static const int maxn = 500'000;

int last_ans;

bool ask(int x) {
    cout << "? " << x << endl;
    cin >> last_ans;
    return last_ans == 1;
}

void solve() {
    int minus = 0;

    vector<int> primes{2, 3, 5, 7, 11, 13, 17};

    int primes_cnt = static_cast<int>(primes.size());

    vector<int> divs;

    for (int p: primes) {
        int delta = 0;
        while (delta + 1 < p && !ask(p)) {
            delta++;
        }
        divs.push_back((minus + delta) % p);
        minus += delta;
    }

    int res = -1;

    for (int i = 0; i <= maxn; i++) {
        bool ok = true;
        for (int j = 0; j < primes_cnt; j++) {
            if (i % primes[j] != divs[j]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            res = i;
            break;
        }
    }

    cout << "! " << res << endl;
    int verdict;
    cin >> verdict;
}

int main() {
    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}
