#include <bits/stdc++.h>
#include "testlib.h"

void check(int test_case) {
    int n = inf.readInt();
    std::vector<bool> data(n);
    for (int i = 0; i < n; i++) {
        data[i] = inf.readInt();
    }
    int index = 0;
    for (int i = 0;; i++) {
        std::string c = ouf.readWord();

        if (c == "F")
            index = (index + 1) % n;
        else if (c == "D")
            index = (index + n - 1) % n;
        else if (c == "C")
            std::cout << ((data[index]) ? 1 : 0) << std::endl;
        else if (c == "S")
            data[index] = !data[index];
        else if (c == "!") {
            int part_ans = ouf.readInt();
            std::cout << ((part_ans == n) ? 1 : 0) << std::endl;

            tout << i << ' ' << n << std::endl;

            if (part_ans != n) {
                quitf(_wa, "guessed: expected %d, got %d in testcase %d", n, part_ans, test_case);
            }
            return;
        } else {
            quitf(_wa, "unknown character : %s in testcase %d", c.c_str(), test_case);
        }
    }
}

int main(int argc, char *argv[]) {
    registerInteraction(argc, argv);

    int tests = inf.readInt();

    std::cout << tests << std::endl;

    for (int test = 1; test <= tests; test++) {
        setTestCase(test);
        check(test);
    }
    quitf(_ok, "all tests cases");
}
