#include "bits/stdc++.h"
#include "testlib.h"

using namespace std;

struct dsu {
    vector<int> v, cnt;
    void build(int n) { v.resize(n); cnt.resize(n); iota(v.begin(), v.end(), 0); fill(cnt.begin(), cnt.end(), 1); }
    dsu() {}
    dsu(int n) { build(n); }
    int get_par(int i) { if (v[i] != i)v[i] = get_par(v[i]); return v[i]; }
    bool check(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); return i1 == i2; }
    void merge(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); if (i1 == i2)return; if (cnt[i1] > cnt[i2])swap(i1, i2); cnt[i1] += cnt[i2]; v[i2] = i1; }
};

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, (int)1e5, "n");
    inf.readSpace();
    int q = inf.readInt(1, (int)2e5, "q");
    inf.readEoln();

    dsu d(n);

    for (int i = 1; i < n; ++i) {
        int a = inf.readInt(1, n, "v");
        if (i + 1 != n) inf.readSpace();
        else inf.readEoln();

        ensuref(!d.check(a - 1, i), "not tree");
        d.merge(a - 1, i);
    }

    while (q--) {
        inf.readInt(1, n, "v");
        inf.readSpace();
        inf.readInt(0, n - 1, "d");
        inf.readEoln();
    }

    inf.readEof();
}
